/*
Nome: 2812_EXPTRGS_GRAVA_CANCELAMENTO_EXP.SQL

Descrio:
   Trigger para gravar as notas fiscais deletadas pelo expedio

Criao:
   28/01/2011 - Wander Dutra de Morais Neto

Descrio: A trigger insere registros na tabela HISTLOGCANCNOTA a partir da excluso de registros da tabela
              ITEMPRODUTO */
create or replace
TRIGGER GRAVA_CANCELAMENTO_EXP
BEFORE DELETE
ON ITEMPRODUTO
FOR EACH ROW
DECLARE
    V_CDOPERCANCNF HISTLOGCANCNOTA.CDOPERCANCNF%TYPE;
    V_CDCLIFILCANC HISTLOGCANCNOTA.CDCLINFCANC%TYPE;
    V_DTLANCNFCANC HISTLOGCANCNOTA.DTLANCNFCANC%TYPE;
    V_NREXPCANC HISTLOGCANCNOTA.NREXPCANC%TYPE;
    V_IDORIGDESNFCAN HISTLOGCANCNOTA.IDORIGDESNFCAN%TYPE;
    V_IDENTRSAIDOP NOTAFISCAL.IDENTRSAIDOP%TYPE;
    V_IDSISTEMA NOTAFISCAL.IDSISTEMA%TYPE;
BEGIN
      BEGIN
             SELECT DECODE(IDORIGDESTNF, 'C', CDCLIENTE, CDFILIRECE), NREXPEDICAO, DTLANCAMENNF, IDORIGDESTNF, IDENTRSAIDOP, IDSISTEMA
             INTO V_CDCLIFILCANC, V_NREXPCANC, V_DTLANCNFCANC, V_IDORIGDESNFCAN, V_IDENTRSAIDOP, V_IDSISTEMA
             FROM NOTAFISCAL N
             WHERE N.CDFILIAL = :OLD.CDFILIAL 
             AND N.NRLANCTONF = :OLD.NRLANCTONF;
      EXCEPTION
             WHEN NO_DATA_FOUND THEN
             V_CDCLIFILCANC := NULL;
             V_NREXPCANC := NULL;
             V_DTLANCNFCANC := NULL; 
             V_IDORIGDESNFCAN := NULL; 
             V_IDENTRSAIDOP := NULL;
             V_IDSISTEMA := NULL;
      END;
      
      BEGIN
            SELECT MAX(CDOPERADOR)
              INTO V_CDOPERCANCNF
              FROM ITEMPEDIDO I
             WHERE I.CDFILIAL = :OLD.CDFILIAL
               AND I.NRPEDIDO = :OLD.NRPEDIDO
               AND I.NRITEMPED = :OLD.NRITEMPED;
      END;   


      IF (V_IDENTRSAIDOP = 'S') AND (V_IDSISTEMA = 'EXP') THEN

              IF (V_IDORIGDESNFCAN = 'C') THEN 
               INSERT INTO HISTLOGCANCNOTA
	            (CDFILIALNFCANC, NRLANCNFCANC, NRSEQITPROCANC, DTHRCANCNF, CDOPERCANCNF, CDCLINFCANC, NREXPCANC, DTLANCNFCANC, CDFILIRECECANC, IDORIGDESNFCAN, CDPRODCANC)
               VALUES (:OLD.CDFILIAL, :OLD.NRLANCTONF, :OLD.NRSEQITPROD, SYSDATE, V_CDOPERCANCNF, V_CDCLIFILCANC, V_NREXPCANC, V_DTLANCNFCANC, NULL, V_IDORIGDESNFCAN, :OLD.CDPRODUTO);
              ELSIF (V_IDORIGDESNFCAN = 'L') THEN                                            
               INSERT INTO HISTLOGCANCNOTA
	            (CDFILIALNFCANC, NRLANCNFCANC, NRSEQITPROCANC, DTHRCANCNF, CDOPERCANCNF, CDCLINFCANC, NREXPCANC, DTLANCNFCANC, CDFILIRECECANC, IDORIGDESNFCAN,  CDPRODCANC)
               VALUES (:OLD.CDFILIAL, :OLD.NRLANCTONF, :OLD.NRSEQITPROD, SYSDATE, V_CDOPERCANCNF,  NULL, V_NREXPCANC, V_DTLANCNFCANC, V_CDCLIFILCANC, V_IDORIGDESNFCAN, :OLD.CDPRODUTO);
              END IF;
      END IF; 
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GRAVA_CANCELAMENTO_EXP','5.20.001'); END;
/