/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Compras e Suprimentos                                                      */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: CARREGA_PERIFORN                                                     */
/*                                                                            */
/* Criao:                                                                   */
/*    06/05/2003 - Joo Fernando dos Reis Corra                              */
/*                                                                            */
/* Manutenes:                                                               */
/*   /  /   -                                                                 */
/*                                                                            */
/******************************************************************************/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
          WHERE
            O.NAME = 'CARREGA_PERIFORN' AND
            TYPE = 'P'                      AND
            U.UID = O.UID                   AND
            U.NAME = USER)

   DROP PROCEDURE CARREGA_PERIFORN;
GO

CREATE PROCEDURE CARREGA_PERIFORN
(
   @P_CDFILIAL        VARCHAR(4),
   @P_CDFORNECED      VARCHAR(21),
   @P_DTPROGENTAF     DATETIME,
   @P_NEW_DTPROGENTAF DATETIME OUTPUT
)
AS
BEGIN
   SET @P_NEW_DTPROGENTAF = NULL;
END;
GO
ALTER PROCEDURE CARREGA_PERIFORN
(
   @P_CDFILIAL        VARCHAR(4),
   @P_CDFORNECED      VARCHAR(21),
   @P_DTPROGENTAF     DATETIME,
   @P_NEW_DTPROGENTAF DATETIME OUTPUT
)
AS
   DECLARE @V_CDPERIENTR      VARCHAR(2);
   DECLARE @V_IDTIPODIA       VARCHAR(1);
   DECLARE @V_IDDIANUTIL      VARCHAR(1);
   DECLARE @V_DIENTREGA       VARCHAR(3);
   DECLARE @V_COUNT           NUMERIC;
   DECLARE @V_NEW_DTPROGENTAF DATETIME;
   DECLARE @V_DATAAUX         DATETIME;
BEGIN
   SELECT
      @V_CDPERIENTR = MAX(REFORFIL.CDPERIENTR),
      @V_IDTIPODIA  = MAX(PERIENTR.IDTIPODIA),
      @V_IDDIANUTIL = MAX(PERIENTR.IDDIANUTIL)
   FROM
      REFORFIL, PERIENTR
   WHERE
      REFORFIL.CDPERIENTR = PERIENTR.CDPERIENTR AND
      REFORFIL.CDFORNECED = @P_CDFORNECED AND
      REFORFIL.CDFILIAL = @P_CDFILIAL;
   SET @V_NEW_DTPROGENTAF = @P_DTPROGENTAF;
   IF @V_IDTIPODIA = 'S' BEGIN
      SELECT
         @V_NEW_DTPROGENTAF = MAX(DATA.DTDATA)
      FROM
         DATA
      WHERE
         SUBSTRING(CONVERT(VARCHAR, DATA.DTDATA, 112), 1, 6) BETWEEN SUBSTRING(CONVERT(VARCHAR, DATEADD(MM, -1, @P_DTPROGENTAF), 112), 1, 6) AND
                                                                     SUBSTRING(CONVERT(VARCHAR, @P_DTPROGENTAF, 112), 1, 6) AND
         EXISTS(SELECT DIASENTR.CDPERIENTR
                FROM DIASENTR
                WHERE
                   DATEPART(DW, DATA.DTDATA) = CONVERT(NUMERIC, DIASENTR.DIENTREGA) AND
                   DIASENTR.CDPERIENTR = @V_CDPERIENTR AND
                   (((DAY(DATA.DTDATA) + 6) / 7) + IDOCOR01 = 2 OR
                    ((DAY(DATA.DTDATA) + 6) / 7) + IDOCOR02 = 3 OR
                    ((DAY(DATA.DTDATA) + 6) / 7) + IDOCOR03 = 4 OR
                    ((DAY(DATA.DTDATA) + 6) / 7) + IDOCOR04 = 5 OR
                    ((DAY(DATA.DTDATA) + 6) / 7) + IDOCOR05 = 6)) AND
         CONVERT(DATETIME, CONVERT(VARCHAR, DATA.DTDATA, 103)) <= CONVERT(DATETIME, CONVERT(VARCHAR, @P_DTPROGENTAF, 103));
   END;
   IF @V_IDTIPODIA = 'R' BEGIN
      SELECT
         @V_NEW_DTPROGENTAF = MAX(C.DTENTREGA)
      FROM
         CALECOMP C
      WHERE C.CDFILIAL    = @P_CDFILIAL
        AND C.CDPERIENTR  = @V_CDPERIENTR
        AND C.DTENTREGA  <= @P_DTPROGENTAF;

      IF @V_NEW_DTPROGENTAF IS NULL BEGIN
         SET @V_NEW_DTPROGENTAF = @P_DTPROGENTAF;
      END;
   END;
   IF @V_IDTIPODIA = 'M' BEGIN
      SELECT @V_DIENTREGA = MAX(DIENTREGA)
      FROM
        (SELECT '-'+DIENTREGA DIENTREGA
         FROM DIASENTR
         WHERE CDPERIENTR = @V_CDPERIENTR
         UNION ALL
         SELECT DIENTREGA
         FROM DIASENTR
         WHERE CDPERIENTR = @V_CDPERIENTR) A
      WHERE
         DIENTREGA <= SUBSTRING(CONVERT(VARCHAR, @P_DTPROGENTAF, 103), 1, 2);

      IF SUBSTRING(@V_DIENTREGA, 1, 1) = '-' BEGIN

         IF SUBSTRING(CONVERT(VARCHAR, DATEADD(MM, -1, @P_DTPROGENTAF), 103), 4, 2) = '02' AND
            SUBSTRING(@V_DIENTREGA, 2, 2) IN ('29', '30', '31') BEGIN
            SET @V_DIENTREGA = '-'+CONVERT(VARCHAR, DAY(DATEADD(MM, 1, SUBSTRING(CONVERT(VARCHAR, DATEADD(MM, -1, @P_DTPROGENTAF), 103), 1, 10)) - DAY(DATEADD(MM, 1, SUBSTRING(CONVERT(VARCHAR, DATEADD(MM, -1, @P_DTPROGENTAF), 103), 1, 10)))));
         END;
         SET @V_NEW_DTPROGENTAF = CONVERT(DATETIME, SUBSTRING(@V_DIENTREGA, 2, 2)+SUBSTRING(CONVERT(VARCHAR, DATEADD(MM, -1, @P_DTPROGENTAF), 103), 3, 8), 103);
      END
      ELSE BEGIN
         SET @V_NEW_DTPROGENTAF = CONVERT(DATETIME, SUBSTRING(@V_DIENTREGA, 1, 2)+SUBSTRING(CONVERT(VARCHAR, @P_DTPROGENTAF, 103), 3, 8), 103);
      END;
   END;

   IF @V_IDDIANUTIL = 'S' BEGIN
      SELECT @V_COUNT = COUNT(*)
      FROM FERICOMP
      WHERE CDFILIAL = @P_CDFILIAL AND
            DTFERICOMP = @V_NEW_DTPROGENTAF;
      IF @V_COUNT > 0 BEGIN
         SET @V_DATAAUX = @V_NEW_DTPROGENTAF - 1;
         EXEC CARREGA_PERIFORN @P_CDFILIAL, @P_CDFORNECED, @V_DATAAUX, @P_NEW_DTPROGENTAF = @V_NEW_DTPROGENTAF OUTPUT;
      END;
   END;
   SET @P_NEW_DTPROGENTAF = @V_NEW_DTPROGENTAF;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'CARREGA_PERIFORN','5.65.XXX';
GO

